///////////////////////////////////////////////////////////////
//	PAQD2 0.284 (2004.8.15) [Source File] Author:Dwing
///////////////////////////////////////////////////////////////
#include<windows.h>
#include<stdio.h>
#include<string.h>
#include<math.h>
#include"paq.h"
#pragma warning(disable:4035)
#pragma warning(disable:4146)
#pragma warning(disable:4244)
///////////////////////////////////////////////////////////////
#define		MEM 3	// for experimental version
//unsigned	MEM=3;	// for released version
Random		rnd;
Hash		hash;
Ch			ch;
MultiMixer	mixer;
///////////////////////////////////////////////////////////////
void handler()
{
	printf("FINAL ERROR: Not Enough Memory!\n");
	exit(0);
}
///////////////////////////////////////////////////////////////
void handler1()
{
	printf("FINAL ERROR: Can't write archive!\n");
	exit(0);
}
///////////////////////////////////////////////////////////////
inline void Random::init()
{
	memset(this,0,sizeof(Random));
	table[0]=123456789;
	table[1]=987654321;
	for(int j=2;j<256;j++)
		table[j]=table[j-1]*11+table[j-2]*19/16;
}
inline U32 Random::operator()()
{
	__asm			//	i=U8(i+1);
	{				//	return table[i]^=table[U8(i+143)];
		xor eax,eax
		mov al,rnd.i
		inc al
		mov rnd.i,al
		lea edx,[offset rnd.table+eax*4]
		add al,143
		mov eax,[offset rnd.table+eax*4]
		xor eax,[edx]
		mov [edx],eax
	}
}
///////////////////////////////////////////////////////////////
inline void Hash::init()
{
	memset(this,0,sizeof(Hash));
	int i,j;
	for(i=3;i>=0;i--)
		for(j=0;j<256;j++)
			table[i][j]=rnd();
}
///////////////////////////////////////////////////////////////
inline void Ch::init()
{
	memset(this,0,sizeof(Ch));
	N=1<<(21+MEM);
	buf=(U8*)calloc(N,1);
	if(!buf) handler();
	lo=buf[0]=1;
	N--;
}
inline void Ch::update(int y)
{
	bp++; bt=y;
	buf[p]+=buf[p]+y;
	lo	  +=lo   +y;
	if(lo>=16)
	{
		lo=1;
		if(!(bp&=7))
		{
			lpos[buf[p]][++lidx[buf[p]]&7]=p;
			p=(p+1)&N;
			buf[p]=1;
		}
	}
	if(bp==4) hi=buf[p]&15;
	b1=buf[(p-1)&N];
	b2=buf[(p-2)&N];
	b3=buf[(p-3)&N];
	b4=buf[(p-4)&N];
}
///////////////////////////////////////////////////////////////
void Mixer::init()
{
	memset(this,0,sizeof(Mixer));
	n=-1;
	U32* p=&wt[0][0];
	__asm	xor eax,eax			//	for(i=0;i<C;i++)
	__asm	mov edi,p			//		for(j=0;j<N;j++)
	__asm	inc eax				//			wt[i][j]=1;
	__asm	mov ecx,32*64	//C*N
	__asm	rep stosd
}
inline int Mixer::predict(int vc)
{
	c=vc; b1=b0=1;
	for(int j=n;j>=0;j--)
	{
		b0+=bc0[j]*wt[c][j];
		b1+=bc1[j]*wt[c][j];
	}
	__asm{
		mov edx,[ecx]this.b1
		xor eax,eax
		mov ebx,[ecx]this.b0
		add ebx,edx
		div ebx
		shr eax,20
	}//	return int(float(b1)*PSCALE/(b0+b1));
}
///////////////////////////////////////////////////////////////
void Mixer1::update(int y)
{
	int dw,m0,m1;
	U32 s0,s1;
	if((s0=n*48+b0)>0 && (s1=n*48+b1)>0)
	{
		U32 rn=rnd();
		U32 sy=(0xffffffff/(y?s1:s0)	+(rn&127))		>>7;
		const U32 su=(0xffffffff/(s0+s1)+((rn>>7)&127))	>>7;
		sy-=su;
		if(y)	{m0=-su;m1=sy;}
		else	{m1=-su;m0=sy;}
		rn>>=22;
		for(int i=0;i<=n;i++)
		{
			dw=int(wt[c][i])+(int(bc0[i]*m0+bc1[i]*m1+rn)>>10);
			if(dw<1) dw=1; else if(dw>0xffff) dw=0xffff;
			wt[c][i]=dw;
		}
	}
	n=-1;
}
///////////////////////////////////////////////////////////////
void Mixer2::update(int y)
{
	int dw,m0,m1;
	if(b0>0 && b1>0)
	{
		const U32 sy=0x30000/(y?b1:b0);
		const U32 su=0x30000/(b0+b1);
		const U32 syd=sy-su;
		if(y)	{m0=-su-1;m1=syd;}
		else	{m1=-su-1;m0=syd;}
		U32 rn=rnd()&255;
		for(int i=0;i<=n;i++)
		{
			dw=int(wt[c][i])+(int(bc0[i]*m0+bc1[i]*m1+rn)>>8);
			if(dw<1) dw=1; else if(dw>0xffff) dw=0xffff;
			wt[c][i]=dw;
		}
	}
	n=-1;
}
///////////////////////////////////////////////////////////////
inline void MultiMixer::write(int n0,int n1)
{
	m1.write(n0,n1);
	if(MEM>=3) m2.write(n0,n1);
}
inline void MultiMixer::add(int n0,int n1)
{
	m1.add(n0,n1);
	if(MEM>=3) m2.add(n0,n1);
}
inline int MultiMixer::predict()
{
	U32 p1=m1.predict((ch.b1>>3));
	if(MEM>=3)
	{
		U32 p2=m2.predict((ch.b1>>6)*4+(ch.b2>>6));
		return (p1+p2)>>1;
	}
	else return p1;
}
inline void MultiMixer::update(int y)
{
	m1.update(y);
	if(MEM>=3) m2.update(y);
}
///////////////////////////////////////////////////////////////
inline void Counter::add(int y)
{
	if(y)	if(state<=213||table[state].p1>=rnd())
					state=table[state].s11;
			else	state=table[state].s10;
	else	if(state<=213||table[state].p0>=rnd())
					state=table[state].s01;
			else	state=table[state].s00;
}
///////////////////////////////////////////////////////////////
Hashtable::Hashtable(U32 n):N(n>4?n-4:0)
{
	p=(char*)calloc((16<<N)+64,1);
	if(!p) handler();
	table=(HashElement*)(U32(p+63)&-64);
	Tcxt=&(table[0].c[-1]);
}
void Hashtable::set(U32 h)
{
	const U8  checksum=(U8)(h+(h>>16));
	const U32 lo=(h>>(32-N))&-4;
	const U32 hi=lo+4;
	for(U32 i=lo;i<hi;i++)
		if(table[i].checksum==checksum) goto _jp2;
		else if(!table[i].c[0].state)
		{
			table[i].checksum=checksum;
_jp2:		if(i!=lo)
			{
				HashElement he=table[i];
				do table[i]=table[i-1];	while(--i>lo);
				table[i]=he;
			}
			Tcxt=&(table[i].c[-1]);
			return;
		}
	table[lo+3]=table[lo+2];
	table[lo+2]=table[lo+1];
	table[lo+1]=table[lo];
	memset(table+lo,0,16);
	table[lo].checksum=checksum;
	Tcxt=&(table[lo].c[-1]);
}
///////////////////////////////////////////////////////////////
inline CounterMap1::CounterMap1(int n):N(n>1?n-1:0)
{
	cxt=t=(S*)calloc(1<<N,sizeof(S));
	if(!t) handler();
}
inline void CounterMap1::update(U32 h)
{
	if(!ch.bp)
		if(!cxt->n)
		{	cxt->n=1; cxt->c=ch.b1;			}
		else 
			if(U32(cxt->c)==ch.b1)
			{	if(cxt->n<255) ++cxt->n;	}
			else
			{	cxt->n=1; cxt->c=ch.b1;		}
	cxt=t+((h+(h<<16)) >> (32-N));
}
inline void CounterMap1::add()
{
	U32 d=((cxt->c+256) >> (7-ch.bp));
	if(!(d^=(ch()<<1)))	mixer.add(cxt->n,0);
	else if(d==1)		mixer.add(0,cxt->n);
}
///////////////////////////////////////////////////////////////
inline CounterMap2::CounterMap2(int n):cxt(0),ht2(n)
{
	memset(cp,0,sizeof(Counter*)*8);
}
inline void CounterMap2::update(U32 h)
{
	const U32 c=ch.b1;
	for(int i=0;i<8;i++)
		if(cp[i])
		{
			cp[i]->add((c>>(7-i))&1);
			cp[i]=0;
		}
	cxt=h;
	ht2.set(cxt);
}
inline void CounterMap2::write()
{
	const U32 bcount=ch.bp;
	if(bcount==4)
	{
		cxt^=hash((U8)ch.hi);
		ht2.set(cxt);
	}
	cp[bcount]=&ht2(ch.lo);
	mixer.write(cp[bcount]->get0(),cp[bcount]->get1());
}
inline void CounterMap2::add()
{
	const U32 bcount=ch.bp;
	if(bcount==4)
	{
		cxt^=hash((U8)ch.hi);
		ht2.set(cxt);
	}
	cp[bcount]=&ht2(ch.lo);
	mixer.add(cp[bcount]->get0(),cp[bcount]->get1());
}
///////////////////////////////////////////////////////////////
inline CounterMap::CounterMap(int n):cm1(MEM>=3?n-2:0),cm2(n){}
inline void CounterMap::update(U32 h)
{
	if(MEM>=3) cm1.update(h);
	cm2.update(h);
}
inline void CounterMap::write()
{
	if(MEM>=3) cm1.add();
	cm2.write();
}
inline void CounterMap::add()
{
	if(MEM>=3) cm1.add();
	cm2.add();
}
///////////////////////////////////////////////////////////////
inline CharModel::CharModel():SIZE(MEM+21),
		t2(SIZE-2),t3(SIZE-1),t4(SIZE),t5(SIZE),t6(SIZE),t7(SIZE),
		t8((MEM>=2)*(SIZE-1)),t9((MEM>=2)*(SIZE-1)),cp0(&t0[0]),cp1(&t1[0])
{
	memset(t0, 0,sizeof(Counter)*256);
	memset(t1, 0,sizeof(Counter)*65536);
	memset(cxt,0,sizeof(U32)*N);
}//10 28 56 56
void CharModel::model()
{
	int i,y=ch.bt;
	cp0->add(y);
	cp1->add(y);
	cp0=&t0[ch()];
	cp1=&t1[ch()+256*ch.b1];
	mixer.write(cp0->get0(),cp0->get1());
	mixer.write(cp1->get0(),cp1->get1());
	if(!ch.bp)
	{
		for(i=N-3+(MEM&2);i>0;i--)
			cxt[i]=cxt[i-1]^hash(ch.b1,i);
		t2.update(cxt[2]);		t3.update(cxt[3]);
		t4.update(cxt[4]);		t5.update(cxt[5]);
		t6.update(cxt[6]);		t7.update(cxt[7]);
		if(MEM>=2)	{t8.update(cxt[8]);t9.update(cxt[9]);}
	}
	t2.write();	t3.write();		t4.write();
	t5.add();	t6.write();		t7.add();
	if(MEM>=2)	{t8.write();	t9.add();}
}
///////////////////////////////////////////////////////////////
inline MatchModel::MatchModel():N(MEM+19),begin(0),end(0),hash0(0),hash1(0)
{
	ptr=(U32*)calloc(1<<N,4);
	if(!ptr) handler();
}
void MatchModel::model()
{
	int n[2]={0,0};
	U32 h,p,wt,d;
	if(!ch.bp)
	{
		hash0=hash0*(16*56797157)+ch.b1+1;
		hash1=hash1*( 2*45684217)+ch.b1+1;
		if(hash0>>28)	h=hash0>>(32-N);
		else			h=hash1>>(32-N);
		if(end && ch.b1==ch[end]) end++;
		if(!end && end!=ptr[h])
		{
			if((end=ptr[h])>0)
			{
				begin=end; p=ch.p;
				if(begin!=p+1)
					while(begin>0 && p>0 && ch[begin-1]==ch[p-1])
						begin--,p--;
			}
			if(begin==end) begin=end=0;
		}
		ptr[h]=ch.p;
	}
	if(end)
	{
		d=(ch[end]+256) >> (7-ch.bp);
		if((d>>1)!=ch())
			begin=end=0;
		else	
		{
			wt=end-begin;
			if(wt>45)	wt=512;
			else		wt=wt*wt>>2;
			n[d&1]=wt;
		}
	}
	mixer.write(n[0],n[1]);
}
///////////////////////////////////////////////////////////////
inline RecordModel::RecordModel():SIZE(MEM+19),
		t0(SIZE),t3(SIZE),t4(SIZE),rp1(4),rp2(4){}//1.5 3 6 12
void RecordModel::model()
{
	if(!ch.bp)
	{
//		const int d1=ch.pos(0)-ch.pos(1);
//		const int d2=ch.pos(1)-ch.pos(2);
//		const int d3=ch.pos(2)-ch.pos(3);
		int d2=ch.pos(1);
		int d1=ch.pos(0)-d2;
		int d3=ch.pos(2);
		if(d1==(d2-=d3) && d1==(d3-=ch.pos(3)) && d1>1)
			if		(d1==rp1) {d3=rp1;rp1=rp2;rp2=d3;}
			else if	(d1!=rp2) {rp1=rp2;rp2=d1;}

		if(rp1<=rp2)d1=rp1,d2=rp2;
		else		d1=rp2,d2=rp1;
		t0.update(hash(ch(d1),	ch(d1*2),	d1));
		t3.update(hash(ch(d2),	ch(d2*2),	d2));
		t4.update(hash(ch.b1,	ch(d2),		ch(d2+1),	d2));
	}
	t0.write();	t3.write();	t4.write();
}
///////////////////////////////////////////////////////////////
inline SparseModel::SparseModel():SIZE((MEM>=1)*(MEM+18)),
		t2(SIZE),t3(SIZE),t4(SIZE),t5(SIZE),t6(SIZE){}//0 2.5 5 10
void SparseModel::model()
{
	if(!ch.bp)
	{
		t2.update(hash(ch.b1,ch(5)));
		t3.update(hash(ch.b1,ch(6)));
		t4.update(hash(ch.b2,ch.b3));
		t5.update(hash(ch.b2,ch.b4));
		t6.update(hash(ch.b3,ch.b4));
	}
	t2.write();	t3.write();	t4.write();	t5.write();	t6.write();
}
///////////////////////////////////////////////////////////////
inline AnalogModel::AnalogModel():SIZE((MEM>=2)*(MEM+18)),
		t0(SIZE),t1(SIZE),t2(SIZE),t5(SIZE){}//0 0 4 8
void AnalogModel::model()
{
	if(!ch.bp)
	{
		t0.update(hash(ch.b2/4,	ch.b4/4, (U8)(ch.p%2)));// 16 bit mono
		t1.update(hash(ch.b2/16,ch.b4/16,(U8)(ch.p%2)));
		t2.update(hash(ch.b4/4,(ch.b2-ch(6))/4,(ch.b4-ch(8))/8));
		t5.update(hash(ch.b1/2,	ch.b2/8, ch.b3/32));	// 8-bit data
	}
	t0.write();t1.add();t2.add();	t5.write();
}
///////////////////////////////////////////////////////////////
inline WordModel::WordModel():t3((MEM>=1)*(MEM+21)),word(0){}//0 4 8 16
void WordModel::model()
{
	if(!ch.bp)
	{
		int c=ch.b1;
		if(ISLETTER(c))
			word^=hash((U8)word,((c<0x60)?c+32:c));
		else word=0;
		t3.update(word);
	}
	t3.write();	
}
///////////////////////////////////////////////////////////////
void ExeModel::model()
{
	int i,n[2]={0,0};
	U32 a,r,ck;
	if(!ch.bp && ch(5)==0xe8 && (ch.b1==0 || ch.b1==0xff))
	{
		a=ch.b4+(ch.b3<<8)+(ch.b2<<16)+(ch.b1<<24)+ch.p-5;
		i=a&0xff;
		if(t[i].a==a && t[i].n<255)	t[i].n++;
		else						{t[i].a=a;t[i].n=1;}
	}
	if(ch.b4==0xe8)
	{
		i=(ch.b3+ch.p-4)&0xff;
		if(t[i].n>0)
		{
			r=t[i].a-ch.p+4;
			ck=(((r&0xff000000)>>8)+0x1000000)>>(24-ch.bp);
			if(ch()==ck && ch.b1==((r>>16)&0xff))
			{
				n[int(r<<ch.bp)<0]=0x7fff;
				goto _find;
			}
		}
	}
	if(ch.b3==0xe8)
	{
		i=(ch.b2+ch.p-3)&0xff;
		if(t[i].n>0)
		{
			r=t[i].a-ch.p+3;
			ck=((r&0xff0000)+0x1000000)>>(24-ch.bp);
			if(ch()==ck && ch.b1==((r>>8)&0xff))
			{
				n[int(r<<(ch.bp+8))<0]=0x7fff;
				goto _find;
			}
		}
	}
	if(ch.b2==0xe8)
	{
		i=(ch.b1+ch.p-2)&0xff;
		if(t[i].n>0)
		{
			r=t[i].a-ch.p+2;
			ck=((r&0xff00)+0x10000)>>(16-ch.bp);
			if(ch()==ck)
			{
				n[int(r<<(ch.bp+16))<0]=t[i].n*(ch.bp+9);
				goto _find;
			}
		}
	}
	return;
_find:	mixer.write(n[0],n[1]);
}
///////////////////////////////////////////////////////////////
inline Predictor::SSEMap::SSEMap()
{
	int i,p;
	for(i=0;i<PSCALE;i++)
	{
		p=int(64*log((i+0.5)/(PSCALE-0.5-i))+512);
		if(p>1023)		p=1023;
		else if(p<0)	p=0;
		table[i]=p;
	}
}
///////////////////////////////////////////////////////////////
Predictor::Predictor():nextp(PSCALE/2),ssep(512),context(0)
{
	int n,p,c1,i,j,k;
	int oldp=SSE2+1;
	for(i=PSCALE-1;i>=0;i--)
	{
		p=(ssemap(i)+SSESCALE/2)/SSESCALE;
		n=1+PSCALE*PSCALE/((i+1)*(PSCALE-i));
		if(n>254) n=254;
		c1=(i*n+PSCALE/2)/PSCALE;
		for(j=oldp-1;j>=p;j--)
			for(k=0;k<SSE1;k++)
			{
				sse[k][j].n=n;
				sse[k][j].c1=c1;
			}
		oldp=p;
	}
}
void Predictor::update(int y)
{
	sse[context][ssep/SSESCALE].update(y);
	sse[context][ssep/SSESCALE+1].update(y);
	mixer.update(y);
	ch.update(y);
	mixer.write(8,8);
	charModel.model();
	matchModel.model();
	recordModel.model();
	if(MEM)   sparseModel.model();
	if(MEM>1) analogModel.model();
	if(MEM)   wordModel.model();
	exeModel.model();
	nextp=mixer.predict();
	context=ch()*4+ch.b1/64;
	ssep=ssemap(nextp);
	const U32 wt=ssep%SSESCALE;
	const U32  i=ssep/SSESCALE;
	nextp=(((sse[context][i  ].p()*(SSESCALE-wt)+
			 sse[context][i+1].p()*wt)/SSESCALE)*3+nextp)>>2;
}
///////////////////////////////////////////////////////////////
Encoder::Encoder(Mode m,FILE* f):predictor(),mode(m),archive(f),
	x1(0),x2(0xffffffff),x(0),bits_to_follow(0),bptr(128),
	bout(0),bptrin(1),bin(0)
{
	rnd.init();
	hash.init();
	mixer.init();
	ch.init();
	if(mode==DECOMPRESS)
	{
		for(x=1;x<Half;)
			x+=x+input_bit();
		x+=x+input_bit();
	}
}
Encoder::~Encoder()	{ch.free();}
inline int Encoder::input_bit()
{
	if(!(bptrin>>=1))
	{
		if((bin=getc(archive))==EOF) bin=0;
		bptrin=128;
	}
	return ((bin&bptrin)!=0);
}
inline void Encoder::bit_plus_follow(int bit)
{ 
	if(bit) bout|=bptr;
	if(!(bptr>>=1))
	{
		while(putc(bout,archive)==EOF) handler1();
		bptr=128;
		bout=0;
	}
	for(;bits_to_follow>0;bits_to_follow--)
	{
		if(!bit) bout|=bptr;
		if(!(bptr>>=1)) 
		{
			while(putc(bout,archive)==EOF) handler1();
			bptr=128;
			bout=0;
		}
	}
}
void Encoder::encode(U32 y)
{
	const U32 xdiff=x2-x1;
	U32 a=xdiff>>13;
	U32 b=xdiff&0x1fff;
	U32 c=predictor.p()*2+1;
	U32 xmid=x1+a*c+((c*b)>>13);
	if(y)	x2=xmid;
	else	x1=xmid+1;
	predictor.update(y);
	while(1)
	{
		if(x2<Half)			bit_plus_follow(0);
		else if(x1>=Half)	bit_plus_follow(1);
		else if(x1>=First_qtr && x2<Third_qtr) 
		{
			bits_to_follow++;
			x1^=First_qtr;
			x2^=First_qtr;
		} 
		else break;
		x1+=x1;
		x2+=x2+1;
	}
}
U32 Encoder::decode()
{
	int y=0;
	const U32 xdiff=x2-x1;
	U32 a=xdiff>>13;
	U32 b=xdiff&0x1fff;
	U32 c=predictor.p()*2+1;
	U32 xmid=x1+a*c+((c*b)>>13);
	if(x<=xmid) {y=1;x2=xmid;	}
	else		{x1=xmid+1;		}
	predictor.update(y);
	while(1)
	{
		if(x2>=Half)
			if(x1>=Half)
			{	x1-=Half;x-=Half;x2-=Half;	} 
			else if(x1>=First_qtr && x2<Third_qtr) 
			{	x1-=First_qtr;x-=First_qtr;x2-=First_qtr;	}
			else break;
		x1+=x1;
		x +=x +input_bit();
		x2+=x2+1;
	}
	return y;
}
void Encoder::flush()
{
	if(x1)	bout|=bptr;
	else	if(bits_to_follow)	bit_plus_follow(0);
	while(bout&&putc(bout,archive)==EOF) handler1();
}
///////////////////////////////////////////////////////////////
#define au 0xffffffff
#define bu 0x03ffffff
#define cu 0x01ffffff
#define du 0x007fffff
const Counter::E Counter::table[]=
{
  {  0,  0,0   ,2   ,0   ,1   , au,au}, // 0
  {  0, 10,0   ,4   ,0   ,3   , au,au}, // 1 
  { 10,  0,0   ,5   ,0   ,4   , au,au}, // 2 

  {  0, 15,0   ,4   ,0   ,6   , au,au}, // 3 
  {  3,  3,0   ,13  ,0   ,12  , au,au}, // 4 
  { 15,  0,0   ,9   ,0   ,4   , au,au}, // 5 

  {  0, 19,0   ,12  ,0   ,10  , au,au}, // 6 
  {  4,  5,0   ,17  ,0   ,21  , au,au}, // 7 
  {  5,  4,0   ,24  ,0   ,16  , au,au}, // 8 
  { 19,  0,0   ,19  ,0   ,13  , au,au}, // 9 

  {  0, 23,0   ,22  ,0   ,20  , au,au}, // 10
  {  1,  2,0   ,13  ,0   ,21  , au,au}, // 11

  {  3,  5,0   ,15  ,0   ,21  , au,au}, // 12
  {  5,  3,0   ,24  ,0   ,14  , au,au}, // 13

  {  4,  4,0   ,17  ,0   ,12  , au,au}, // 14
  {  4,  4,0   ,13  ,0   ,16  , au,au}, // 15
  {  4,  4,0   ,17  ,0   ,7   , au,au}, // 16
  {  4,  4,0   ,8   ,0   ,16  , au,au}, // 17

  {  2,  1,0   ,24  ,0   ,12  , au,au}, // 18
  { 23,  0,0   ,25  ,0   ,23  , au,au}, // 19

  {  0, 26,0   ,28  ,0   ,26  , au,au}, // 20
  {  1,  4,0   ,12  ,0   ,27  , au,au}, // 21
  {  2,  3,0   ,18  ,0   ,21  , au,au}, // 22
  {  3,  2,0   ,24  ,0   ,11  , au,au}, // 23
  {  4,  1,0   ,31  ,0   ,13  , au,au}, // 24
  { 26,  0,0   ,32  ,0   ,30  , au,au}, // 25

  {  0, 29,0   ,35  ,0   ,33  , au,au}, // 26
  {  1,  5,0   ,12  ,0   ,34  , au,au}, // 27
  {  1,  4,0   ,23  ,0   ,27  , au,au}, // 28
  {  2,  2,0   ,24  ,0   ,21  , au,au}, // 29
  {  4,  1,0   ,31  ,0   ,22  , au,au}, // 30
  {  5,  1,0   ,39  ,0   ,13  , au,au}, // 31
  { 29,  0,0   ,40  ,0   ,38  , au,au}, // 32

  {  0, 32,0   ,43  ,0   ,41  , au,au}, // 33
  {  1,  6,0   ,22  ,0   ,42  , au,au}, // 34
  {  1,  2,0   ,23  ,0   ,34  , au,au}, // 35
  {  1,  1,0   ,30  ,0   ,27  , au,au}, // 36
  {  1,  1,0   ,31  ,0   ,28  , au,au}, // 37
  {  2,  1,0   ,39  ,0   ,22  , au,au}, // 38
  {  6,  1,0   ,48  ,0   ,23  , au,au}, // 39
  { 32,  0,0   ,49  ,0   ,47  , au,au}, // 40

  {  0, 35,0   ,52  ,0   ,50  , au,au},	// 41
  {  1,  7,0   ,22  ,0   ,51  , au,au},
  {  1,  3,0   ,29  ,0   ,42  , au,au},
  {  1,  1,0   ,30  ,0   ,34  , au,au},
  {  1,  1,0   ,38  ,0   ,35  , au,au},
  {  1,  1,0   ,39  ,0   ,28  , au,au},
  {  3,  1,0   ,48  ,0   ,29  , au,au},
  {  7,  1,0   ,58  ,0   ,23  , au,au},
  { 35,  0,0   ,59  ,0   ,57  , au,au},
  {  0, 38,0   ,62  ,0   ,60  , au,au},	// 50
  {  1,  8,0   ,28  ,0   ,61  , au,au},
  {  1,  3,0   ,29  ,0   ,51  , au,au},
  {  1,  2,0   ,37  ,0   ,42  , au,au},
  {  1,  1,0   ,38  ,0   ,43  , au,au},
  {  1,  1,0   ,47  ,0   ,35  , au,au},
  {  2,  1,0   ,48  ,0   ,36  , au,au},
  {  3,  1,0   ,58  ,0   ,29  , au,au},
  {  8,  1,0   ,66  ,0   ,30  , au,au},
  { 38,  0,0   ,67  ,0   ,65  , au,au},
  {  0, 41,0   ,70  ,0   ,68  , au,au},	// 60
  {  1,  9,0   ,28  ,0   ,69  , au,au},
  {  1,  4,0   ,36  ,0   ,61  , au,au},
  {  1,  2,0   ,37  ,0   ,51  , au,au},
  {  2,  1,0   ,58  ,0   ,36  , au,au},
  {  4,  1,0   ,66  ,0   ,37  , au,au},
  {  9,  1,0   ,74  ,0   ,30  , au,au},
  { 41,  0,0   ,75  ,0   ,73  , au,au},
  {  0, 44,0   ,78  ,0   ,76  , au,au},
  {  1, 10,0   ,35  ,0   ,77  , au,au},
  {  1,  4,0   ,36  ,0   ,69  , au,au},	//70
  {  1,  2,0   ,45  ,0   ,61  , au,au},
  {  2,  1,0   ,66  ,0   ,45  , au,au},
  {  4,  1,0   ,74  ,0   ,37  , au,au},
  { 10,  1,0   ,82  ,0   ,38  , au,au},
  { 44,  0,0   ,83  ,0   ,81  , au,au},
  {  0, 47,0   ,86  ,0   ,84  , au,au},
  {  1, 11,0   ,35  ,0   ,85  , au,au},
  {  1,  5,0   ,44  ,0   ,77  , au,au},
  {  1,  3,0   ,45  ,0   ,69  , au,au},
  {  3,  1,0   ,74  ,0   ,45  , au,au},	//80
  {  5,  1,0   ,82  ,0   ,46  , au,au},
  { 11,  1,0   ,90  ,0   ,38  , au,au},
  { 47,  0,0   ,91  ,0   ,89  , au,au},
  {  0, 50,0   ,94  ,0   ,92  , au,au},
  {  1, 12,0   ,43  ,0   ,93  , au,au},
  {  1,  5,0   ,44  ,0   ,85  , au,au},
  {  1,  3,0   ,54  ,0   ,77  , au,au},
  {  3,  1,0   ,82  ,0   ,55  , au,au},
  {  5,  1,0   ,90  ,0   ,46  , au,au},
  { 12,  1,0   ,96  ,0   ,47  , au,au},	//90
  { 50,  0,0   ,97  ,0   ,95  , au,au},
  {  0, 52,0   ,100 ,0   ,98  , au,au},
  {  1, 13,0   ,43  ,0   ,99  , au,au},
  {  1,  6,0   ,53  ,0   ,93  , au,au},
  {  6,  1,0   ,96  ,0   ,56  , au,au},
  { 13,  1,0   ,102 ,0   ,47  , au,au},
  { 52,  0,0   ,103 ,0   ,101 , au,au},
  {  0, 54,0   ,106 ,0   ,104 , au,au},
  {  1, 14,0   ,52  ,0   ,105 , au,au},
  {  1,  6,0   ,53  ,0   ,99  , au,au},	//100
  {  6,  1,0   ,102 ,0   ,56  , au,au},
  { 14,  1,0   ,108 ,0   ,57  , au,au},
  { 54,  0,0   ,109 ,0   ,107 , au,au},
  {  0, 56,0   ,112 ,0   ,110 , au,au},
  {  1, 15,0   ,52  ,0   ,111 , au,au},
  {  1,  7,0   ,63  ,0   ,105 , au,au},
  {  7,  1,0   ,108 ,0   ,64  , au,au},
  { 15,  1,0   ,114 ,0   ,57  , au,au},
  { 56,  0,0   ,115 ,0   ,113 , au,au},
  {  0, 58,0   ,112 ,0   ,116 , au,au},	//110
  {  1, 16,0   ,62  ,0   ,117 , au,au},
  {  1,  7,0   ,63  ,0   ,111 , au,au},
  {  7,  1,0   ,114 ,0   ,64  , au,au},
  { 16,  1,0   ,118 ,0   ,65  , au,au},
  { 58,  0,0   ,119 ,0   ,113 , au,au},
  {  0, 60,0   ,122 ,0   ,120 , au,au},
  {  1, 17,0   ,62  ,0   ,121 , au,au},
  { 17,  1,0   ,124 ,0   ,65  , au,au},
  { 60,  0,0   ,125 ,0   ,123 , au,au},
  {  0, 61,0   ,128 ,0   ,126 , au,au},	//120
  {  1, 18,0   ,70  ,0   ,127 , au,au},
  {  1,  8,0   ,71  ,0   ,121 , au,au},
  {  8,  1,0   ,124 ,0   ,72  , au,au},
  { 18,  1,0   ,130 ,0   ,73  , au,au},
  { 61,  0,0   ,131 ,0   ,129 , au,au},
  {  0, 62,0   ,134 ,0   ,132 , au,au},
  {  1, 19,0   ,70  ,0   ,133 , au,au},
  {  1,  9,0   ,79  ,0   ,127 , au,au},
  {  9,  1,0   ,130 ,0   ,80  , au,au},
  { 19,  1,0   ,136 ,0   ,73  , au,au},	//130
  { 62,  0,0   ,137 ,0   ,135 , au,au},
  {  0, 63,0   ,140 ,0   ,138 , au,au},
  {  1, 20,0   ,78  ,0   ,139 , au,au},
  {  1,  9,0   ,79  ,0   ,133 , au,au},
  {  9,  1,0   ,136 ,0   ,80  , au,au},
  { 20,  1,0   ,142 ,0   ,81  , au,au},
  { 63,  0,0   ,143 ,0   ,141 , au,au},
  {  0, 64,0   ,146 ,0   ,144 , au,au},
  {  1, 21,0   ,78  ,0   ,145 , au,au},
  {  1, 10,0   ,87  ,0   ,139 , au,au},	//140
  { 10,  1,0   ,142 ,0   ,88  , au,au},
  { 21,  1,0   ,148 ,0   ,81  , au,au},
  { 64,  0,0   ,149 ,0   ,147 , au,au},
  {  0, 65,0   ,146 ,0   ,150 , au,au},
  {  1, 22,0   ,86  ,0   ,151 , au,au},
  {  1, 10,0   ,87  ,0   ,145 , au,au},
  { 10,  1,0   ,148 ,0   ,88  , au,au},
  { 22,  1,0   ,152 ,0   ,89  , au,au},
  { 65,  0,0   ,153 ,0   ,147 , au,au},
  {  0, 66,0   ,77  ,0   ,154 , au,au},	//150
  {  1, 23,0   ,86  ,0   ,155 , au,au},
  { 23,  1,0   ,156 ,0   ,89  , au,au},
  { 66,  0,0   ,157 ,0   ,82  , au,au},
  {  0, 67,0   ,77  ,0   ,158 , au,au},
  {  1, 24,0   ,86  ,0   ,159 , au,au},
  { 24,  1,0   ,160 ,0   ,89  , au,au},
  { 67,  0,0   ,161 ,0   ,82  , au,au},
  {  0, 68,0   ,77  ,0   ,162 , au,au},
  {  1, 25,0   ,86  ,0   ,163 , au,au},
  { 25,  1,0   ,164 ,0   ,89  , au,au},	//160
  { 68,  0,0   ,165 ,0   ,82  , au,au},
  {  0, 69,0   ,77  ,0   ,166 , au,au},
  {  1, 26,0   ,86  ,0   ,167 , au,au},
  { 26,  1,0   ,168 ,0   ,89  , au,au},
  { 69,  0,0   ,169 ,0   ,82  , au,au},
  {  0, 70,0   ,77  ,0   ,170 , au,au},
  {  1, 27,0   ,86  ,0   ,171 , au,au},
  { 27,  1,0   ,172 ,0   ,89  , au,au},
  { 70,  0,0   ,173 ,0   ,82  , au,au},
  {  0, 71,0   ,77  ,0   ,174 , au,au},	//170
  {  1, 28,0   ,86  ,0   ,175 , au,au},
  { 28,  1,0   ,176 ,0   ,89  , au,au},
  { 71,  0,0   ,177 ,0   ,82  , au,au},
  {  0, 72,0   ,77  ,0   ,178 , au,au},
  {  1, 29,0   ,86  ,0   ,179 , au,au},
  { 29,  1,0   ,180 ,0   ,89  , au,au},
  { 72,  0,0   ,181 ,0   ,82  , au,au},
  {  0, 73,0   ,77  ,0   ,182 , au,au},
  {  1, 30,0   ,86  ,0   ,183 , au,au},
  { 30,  1,0   ,184 ,0   ,89  , au,au},	//180
  { 73,  0,0   ,185 ,0   ,82  , au,au},
  {  0, 74,0   ,77  ,0   ,186 , au,au},
  {  1, 31,0   ,86  ,0   ,187 , au,au},
  { 31,  1,0   ,188 ,0   ,89  , au,au},
  { 74,  0,0   ,189 ,0   ,82  , au,au},
  {  0, 75,0   ,77  ,0   ,190 , au,au},
  {  1, 32,0   ,86  ,0   ,191 , au,au},
  { 32,  1,0   ,192 ,0   ,89  , au,au},
  { 75,  0,0   ,193 ,0   ,82  , au,au},
  {  0, 76,0   ,77  ,0   ,194 , au,au},	//190
  {  1, 33,0   ,86  ,0   ,195 , au,au},
  { 33,  1,0   ,196 ,0   ,89  , au,au},
  { 76,  0,0   ,197 ,0   ,82  , au,au},
  {  0, 77,0   ,77  ,0   ,198 , au,au},
  {  1, 34,0   ,86  ,0   ,199 , au,au},
  { 34,  1,0   ,200 ,0   ,89  , au,au},
  { 77,  0,0   ,201 ,0   ,82  , au,au},
  {  0, 78,0   ,85  ,0   ,202 , au,au},
  {  1, 35,0   ,86  ,0   ,203 , au,au},
  { 35,  1,0   ,204 ,0   ,89  , au,au},	//200
  { 78,  0,0   ,205 ,0   ,90  , au,au},
  {  0, 79,0   ,85  ,0   ,206 , au,au},
  {  1, 36,0   ,94  ,0   ,207 , au,au},
  { 36,  1,0   ,208 ,0   ,95  , au,au},
  { 79,  0,0   ,209 ,0   ,90  , au,au},
  {  0, 80,0   ,85  ,0   ,210 , au,au},
  {  1, 37,0   ,94  ,0   ,211 , au,au},
  { 37,  1,0   ,212 ,0   ,95  , au,au},
  { 80,  0,0   ,213 ,0   ,90  , au,au},
  {  0, 81,0   ,85  ,0   ,214 , au,au},	//210
  {  1, 38,0   ,94  ,0   ,215 , au,au},
  { 38,  1,0   ,216 ,0   ,95  , au,au},
  { 81,  0,0   ,217 ,0   ,90  , au,au},	//213

  {  0, 82,0   ,85  ,214 ,220 , au,bu},	//214
  {  1, 39,0   ,94  ,0   ,218 , au,au},
  { 39,  1,0   ,219 ,0   ,95  , au,au},
  { 82,  0,217 ,221 ,0   ,90  , bu,au},
  {  1, 40,0   ,94  ,218 ,222 , au,bu},
  { 40,  1,219 ,223 ,0   ,95  , bu,au},

  {  0, 88,0   ,85  ,220 ,224 , au,bu},	//220
  { 88,  0,221 ,225 ,0   ,90  , bu,au},
  {  1, 44,0   ,94  ,222 ,226 , au,bu},
  { 44,  1,223 ,227 ,0   ,95  , bu,au},

  {  0, 96,0   ,85  ,224 ,228 , au,cu},	//224
  { 96,  0,225 ,229 ,0   ,90  , cu,au},
  {  1, 48,0   ,94  ,226 ,230 , au,cu},
  { 48,  1,227 ,231 ,0   ,95  , cu,au},

  {  0,112,0   ,93  ,228 ,232 , au,cu},	//228
  {112,  0,229 ,233 ,0   ,96  , cu,au},
  {  1, 56,0   ,100 ,230 ,234 , au,cu},
  { 56,  1,231 ,235 ,0   ,101 , cu,au},

  {  0,128,0   ,99  ,232 ,236 , au,du},	//232
  {128,  0,233 ,237 ,0   ,102 , du,au},
  {  1, 64,0   ,106 ,234 ,238 , au,du},
  { 64,  1,235 ,239 ,0   ,107 , du,au},

  {  0,192,0   ,105 ,236 ,240 , au,du},	//236
  {192,  0,237 ,241 ,0   ,108 , du,au},
  {  1, 96,0   ,112 ,238 ,242 , au,du},
  { 96,  1,239 ,243 ,0   ,113 , du,au},

  {  0,256,0   ,117 ,240 ,244 , au,du},	//240
  {256,  0,241 ,245 ,0   ,118 , du,au},
  {  1,128,0   ,122 ,242 ,246 , au,du},
  {128,  1,243 ,247 ,0   ,123 , du,au},

  {  0,320,0   ,121 ,244 ,248 , au,du},	//244
  {320,  0,245 ,249 ,0   ,124 , du,au},
  {  1,160,0   ,128 ,246 ,250 , au,du},
  {160,  1,247 ,251 ,0   ,129 , du,au},

  {  0,384,0   ,127 ,248 ,252 , au,du},	//248
  {384,  0,249 ,253 ,0   ,130 , du,au},
  {  1,192,0   ,134 ,250 ,254 , au,du},
  {192,  1,251 ,255 ,0   ,135 , du,au},

  {  0,512,0   ,133 ,0   ,252 , au,au},	//252
  {512,  0,0   ,253 ,0   ,136 , au,au},
  {  1,256,0   ,140 ,0   ,254 , au,au},
  {256,  1,0   ,255 ,0   ,141 , au,au}	//255
};
///////////////////////////////////////////////////////////////
