///////////////////////////////////////////////////////////////
//	UDA Shell 0.284 (2004.8.15) [Source File] Author:Dwing
///////////////////////////////////////////////////////////////
#include<windows.h>
#include<stdio.h>
#include<io.h>
#include"paq.h"
#define BUFSIZE (1024*32)
const int ZMARK=(('Z')+('D'<<8)+(0x0C<<16)+(3<<24));
//	09 : 0.260-0.27x
//	0A : 0.280-0.282
//	0B : 0.283
//  0C : 0.284
///////////////////////////////////////////////////////////////
int getms()
{
	static unsigned base=0;
	if(base) return GetTickCount()-base;
	else
	{
		base=GetTickCount();
		return 0;
	}
}
///////////////////////////////////////////////////////////////
void compress(char *fname,char *aname)
{
	unsigned long i,ns=0,fs;
	char buf[BUFSIZE];
	FILE *ar,*fp;

	getms();
	if(access(aname,0)!=-1)		{printf("ERROR: %s already exist\n",aname);return;}
	if(!(fp=fopen(fname,"rb"))) {printf("ERROR: Can't open %s\n"   ,fname);return;}
	if(!(ar=fopen(aname,"wb"))) {printf("ERROR: Can't create %s\n" ,aname);fclose(fp);return;}
	printf("%s => %s\n",fname,aname);
	fseek(fp,0,SEEK_END);fs=ftell(fp);fseek(fp,0,SEEK_SET);
	fwrite(&ZMARK,4,1,ar);fwrite(&fs,4,1,ar);
	zUDA z(COMPRESS,ar);
	for(i=0;i<fs/BUFSIZE;i++)
	{
		if(fread(buf,1,BUFSIZE,fp)!=BUFSIZE) {printf("\nERROR: Can't read %s\n",fname);goto _end;}
		z.enc(buf,BUFSIZE);
		ns+=BUFSIZE;
		printf("\r%3.1lf%%",(double)ns*100/fs);
	}
	if((i=fs%BUFSIZE))
	{
		if(fread(buf,1,i,fp)!=i) {printf("\nERROR: Can't read %s\n",fname);goto _end;}
		z.enc(buf,i);
	}
	printf("\r100.0%% Finished!\n");
	if(fs)
	{
		z.flush();
		i=ftell(ar); ns=getms()+1;
		printf("%u/%u in %.2lf sec, %.4lf bpb, %.1lf%% at %.1lf KB/s\n",
			i,fs,(double)ns/1000,(double)i*8/fs,(double)i*100/fs,(double)fs/ns);
	}
_end:
	fclose(ar);
	fclose(fp);
}
///////////////////////////////////////////////////////////////
void extract(char *aname,char *fname)
{
	unsigned long i,ns=0,fs;
	char buf[BUFSIZE];
	FILE *ar,*fp;

	getms();
	if(access(fname,0)!=-1)		 {printf("ERROR: %s already exist\n",fname);return;}
	if(!(ar=fopen(aname,"rb")))  {printf("ERROR: Can't open %s\n",   aname);return;}
	if(!(fp=fopen(fname,"wb")))  {printf("ERROR: Can't create %s\n", fname);fclose(ar);return;}
	printf("%s => %s\n",aname,fname);
	fread(&i,4,1,ar);if(i!=ZMARK){printf("ERROR: Unknown format\n");fclose(fp);fclose(ar);return;}
	fread(&fs,4,1,ar);
	zUDA z(DECOMPRESS,ar);
	for(i=0;i<fs/BUFSIZE;i++)
	{
		z.dec(buf,BUFSIZE);
		if(fwrite(buf,1,BUFSIZE,fp)!=BUFSIZE) {printf("\nERROR: Can't write %s\n",fname);goto _end;}
		ns+=BUFSIZE;
		printf("\r%3.1lf%%",(double)ns*100/fs);
	}
	if((i=fs%BUFSIZE))
	{
		z.dec(buf,i);
		if(fwrite(buf,1,i,fp)!=i) {printf("\nERROR: Can't write %s\n",fname);goto _end;}
	}
	printf("\r100.0%% Finished!\n");
	if(fs)
	{
		i=ftell(ar); ns=getms()+1;
		printf("%u/%u in %.2lf sec, %.4lf bpb, %.1lf%% at %.1lf KB/s\n",
			i,fs,(double)ns/1000,(double)i*8/fs,(double)i*100/fs,(double)fs/ns);
	}
_end:
	fclose(fp);
	fclose(ar);
}
///////////////////////////////////////////////////////////////
void main(int argc,char **argv)
{
	printf( "UDA 0.284 -- Experimental Console Version -- Based on PAQ6 -- 15 Aug 2004\n"
			"Written by Dwing & Matt Mahoney <dwing@163.com> <http://dwing.spymac.net>\n");
	if(argc==4)
		switch(*argv[1])
		{
		case'e':compress(argv[2],argv[3]);	break;
		case'd':extract(argv[2],argv[3]);	break;
		default:printf("ERROR: Unknown command \'%s\'\n",argv[1]);
		}
	else
		printf(	"Usage: uda e <in_filename> <out_filename> --- for compression\n"
				"       uda d <in_filename> <out_filename> --- for decompression\n"
				"Memory needed: 190 MB\n");
}
///////////////////////////////////////////////////////////////
